searchNodes=[{"doc":"A Plug for ensuring that all requests are served by a single canonical host","ref":"PlugCanonicalHost.html","title":"PlugCanonicalHost","type":"module"},{"doc":"Call the plug.","ref":"PlugCanonicalHost.html#call/2","title":"PlugCanonicalHost.call/2","type":"function"},{"doc":"Initialize this plug with a canonical host option.","ref":"PlugCanonicalHost.html#init/1","title":"PlugCanonicalHost.init/1","type":"function"},{"doc":"","ref":"PlugCanonicalHost.html#t:opts/0","title":"PlugCanonicalHost.opts/0","type":"type"},{"doc":"PlugCanonicalHost ensures that all requests are served by a single canonical host. It will redirect all requests from non-canonical hosts to the canonical one.","ref":"readme.html","title":"README","type":"extras"},{"doc":"Add plug_canonical_host to the deps function in your project’s mix.exs file: defp deps do [ … , { :plug_canonical_host , &quot;~&gt; 2.0&quot; } ] end Then run mix do deps.get, deps.compile inside your project’s directory.","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"PlugCanonicalHost can be used just as any other plugs. Add PlugCanonicalHost before all of the other plugs you want to happen after successful redirect to your canonical host. The recommended way to define a canonical host is with an environment variable. # config/releases.exs config :my_app , canonical_host : System . get_env ( &quot;CANONICAL_HOST&quot; ) # lib/my_app/endpoint.ex defmodule MyApp.Endpoint do plug ( :canonical_host ) defp canonical_host ( conn , _opts ) do :my_app |&gt; Application . get_env ( :canonical_host ) |&gt; case do host when is_binary ( host ) -&gt; opts = PlugCanonicalHost . init ( canonical_host : host ) PlugCanonicalHost . call ( conn , opts ) _ -&gt; conn end end end For example, if your CANONICAL_HOST is www.example.com but your application is accessible via both example.com and www.example.com , all traffic coming through example.com will be redirected (with a 301 HTTP status) to the matching www.example.com URL. $ curl -sI &quot;http://example.com/foo?bar=1&quot; #&gt; HTTP/1.1 301 Moved Permanently #&gt; Location: http://www.example.com/foo?bar=1 Allow multiple hosts If you want to support multiple hosts, you can make them skip the canonical host behavior but you’re still going to have to specify a canonical host for unknown hosts redirects. # config/releases.exs config :my_app , canonical_host : System . get_env ( &quot;CANONICAL_HOST&quot; ) , passthrough_hosts : String . split ( System . get_env ( &quot;PASSTHROUGH_HOSTS&quot; ) , &quot;,&quot; ) # lib/my_app/endpoint.ex defmodule MyApp.Endpoint do plug ( :canonical_host ) defp canonical_host ( % Plug.Conn { host : host } = conn , _opts ) do canonical_host = Application . get_env ( :app , :canonical_host ) passthrough_hosts = Application . get_env ( :my_app , :passthrough_hosts ) cond do host in passthrough_hosts -&gt; conn is_binary ( canonical_host ) -&gt; opts = PlugCanonicalHost . init ( canonical_host : canonical_host ) PlugCanonicalHost . call ( conn , opts ) true -&gt; conn end end end Let’s say we have CANONICAL_HOST=www.example.com and PASSTHROUGH_HOSTS=foo.example.com,bar.example.com . Now, all requests going through www.example.com , foo.example.com or bar.example.com path will skip the canonical host redirect behavior. Other hosts will redirect to www.example.com . $ curl -sI &quot;http://example.com/foo?bar=1&quot; #&gt; HTTP/1.1 301 Moved Permanently #&gt; Location: http://www.example.com/foo?bar=1 $ curl -sI &quot;http://foo.example.com/foo?bar=1&quot; #&gt; HTTP/1.1 200 OK $ curl -sI &quot;http://bar.example.com/foo?bar=1&quot; #&gt; HTTP/1.1 200 OK $ curl -sI &quot;http://www.example.com/foo?bar=1&quot; #&gt; HTTP/1.1 200 OK Exclude certain requests If you want to exclude certain requests from redirecting to the canonical host, you can use simple pattern matching in your function arguments: # config/releases.exs config :my_app , canonical_host : System . get_env ( &quot;CANONICAL_HOST&quot; ) # lib/my_app/endpoint.ex defmodule MyApp.Endpoint do plug ( :canonical_host ) defp canonical_host ( % Plug.Conn { request_path : &quot;/ignore-me&quot; } = conn , _opts ) do Plug.Conn . send_resp ( conn , 200 , &quot;👋&quot; ) end defp canonical_host ( conn , _opts ) do :my_app |&gt; Application . get_env ( :canonical_host ) |&gt; case do host when is_binary ( host ) -&gt; opts = PlugCanonicalHost . init ( canonical_host : host ) PlugCanonicalHost . call ( conn , opts ) _ -&gt; conn end end end Now, all requests going to the /ignore-me path will skip the canonical host redirect behavior. $ curl -sI &quot;http://example.com/foo?bar=1&quot; #&gt; HTTP/1.1 301 Moved Permanently #&gt; Location: http://www.example.com/foo?bar=1 $ curl -sI &quot;http://example.com/ignore-me&quot; #&gt; HTTP/1.1 200 OK","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"PlugCanonicalHost is © 2016-2020 Rémi Prévost and may be freely distributed under the MIT license . See the LICENSE.md file for more information. The plug logo is based on this lovely icon by Vectors Market , from The Noun Project. Used under a Creative Commons BY 3.0 license.","ref":"readme.html#license","title":"README - License","type":"extras"}]